CREATE TABLE attemper_arg (
  ARG_NAME NVARCHAR2(64) NOT NULL,
  ARG_TYPE NUMBER(11) NOT NULL,
  ARG_VALUE NVARCHAR2(2000),
  GENERIC_TYPE NUMBER(11),
  ATTRIBUTE NVARCHAR2(2000),
  REMARK NVARCHAR2(255)  ,
  TENANT_ID NVARCHAR2(64)  NOT NULL,
  PRIMARY KEY (ARG_NAME,TENANT_ID)
) ;

/*Table structure for table attemper_calendar */

CREATE TABLE attemper_calendar (
  CALENDAR_NAME NVARCHAR2(64)  NOT NULL,
  DISPLAY_NAME NVARCHAR2(255)  ,
  PRIMARY KEY (CALENDAR_NAME)
) ;

/*Table structure for table attemper_calendar_day */

CREATE TABLE attemper_calendar_day (
  CALENDAR_NAME NVARCHAR2(64)  NOT NULL,
  DAY_NUM NUMBER(8) NOT NULL,
  REMARK NVARCHAR2(255),
  PRIMARY KEY (CALENDAR_NAME,DAY_NUM)
) ;

/*Table structure for table attemper_condition */

CREATE TABLE attemper_condition (
  CONDITION_NAME NVARCHAR2(64)  NOT NULL,
  CONDITION_TYPE NUMBER(11) NOT NULL,
  CONTENT NVARCHAR2(2000)  NOT NULL,
  TENANT_ID NVARCHAR2(64)  NOT NULL,
  PRIMARY KEY (CONDITION_NAME,TENANT_ID)
) ;

/*Table structure for table attemper_datasource */

CREATE TABLE attemper_datasource (
  DB_NAME NVARCHAR2(64) NOT NULL,
  DRIVER_CLASS_NAME NVARCHAR2(64) NOT NULL,
  JDBC_URL NVARCHAR2(255) NOT NULL,
  USER_NAME NVARCHAR2(255),
  PASSWORD NVARCHAR2(255),
  ATTRIBUTE NVARCHAR2(255),
  TENANT_ID NVARCHAR2(64) NOT NULL,
  PRIMARY KEY (DB_NAME,TENANT_ID)
) ;

/*Table structure for table attemper_delay_job */

CREATE TABLE attemper_delay_job (
  ID NVARCHAR2(64) NOT NULL,
  JOB_NAME NVARCHAR2(64) NOT NULL,
  STATUS NUMBER(11),
  REQUEST_TIME NUMBER(13),
  TENANT_ID NVARCHAR2(255) NOT NULL,
  PRIMARY KEY (ID)
);

/*Table structure for table attemper_execution */

CREATE TABLE attemper_execution (
  ID NVARCHAR2(64)  NOT NULL,
  PROC_INST_ID NVARCHAR2(64)  ,
  ROOT_PROC_INST_ID NVARCHAR2(64)  ,
  SUPER_PROC_INST_ID NVARCHAR2(64)  ,
  JOB_NAME NVARCHAR2(64)  ,
  TRIGGER_NAME NVARCHAR2(64)  ,
  PROC_DEF_ID NVARCHAR2(64)  ,
  START_TIME NUMBER(13) ,
  END_TIME NUMBER(13) ,
  DURATION NUMBER(20) ,
  STATUS NUMBER(11),
  CODE NUMBER(11),
  MSG CLOB,
  PARENT_ID NVARCHAR2(64)  ,
  SCHEDULER_URI NVARCHAR2(255)  ,
  EXECUTOR_URI NVARCHAR2(255)  ,
  TENANT_ID NVARCHAR2(64)  ,
  PRIMARY KEY (ID),
  UNIQUE (PROC_INST_ID)
) ;

create index IDX_EXECUTION_JOB_NAME on attemper_execution(JOB_NAME);
create index IDX_EXECUTION_TENANT_ID on attemper_execution(TENANT_ID, 0);

/*Table structure for table attemper_gist */

CREATE TABLE attemper_gist (
  GIST_NAME NVARCHAR2(64)  NOT NULL,
  CREATE_TIME NUMBER(13) NOT NULL,
  TENANT_ID NVARCHAR2(64)  NOT NULL,
  PRIMARY KEY (GIST_NAME,TENANT_ID)
) ;

/*Table structure for table attemper_gist_info */

CREATE TABLE attemper_gist_info (
  ID NVARCHAR2(64) NOT NULL,
  GIST_NAME NVARCHAR2(64) NOT NULL,
  VERSION NVARCHAR2(64) NOT NULL,
  CONTENT CLOB ,
  UPDATE_TIME NUMBER(13) NOT NULL,
  TENANT_ID NVARCHAR2(64) NOT NULL,
  PRIMARY KEY (ID)
) ;

/*Table structure for table attemper_instance */

CREATE TABLE attemper_instance (
  ID NVARCHAR2(64)  NOT NULL,
  PROC_INST_ID NVARCHAR2(64)  ,
  ROOT_PROC_INST_ID NVARCHAR2(64)  ,
  SUPER_PROC_INST_ID NVARCHAR2(64)  ,
  JOB_NAME NVARCHAR2(64),
  TRIGGER_NAME NVARCHAR2(64),
  PROC_DEF_ID NVARCHAR2(64),
  START_TIME NUMBER(13),
  END_TIME NUMBER(13),
  DURATION NUMBER(20),
  STATUS NUMBER(11),
  CODE NUMBER(11),
  MSG CLOB ,
  PARENT_ID NVARCHAR2(64)  ,
  SCHEDULER_URI NVARCHAR2(255)  ,
  EXECUTOR_URI NVARCHAR2(255)  ,
  TENANT_ID NVARCHAR2(64),
  PRIMARY KEY (ID),
  UNIQUE (PROC_INST_ID)
) ;

create index IDX_INSTANCE_JOB_NAME on attemper_instance(JOB_NAME);
create index IDX_INSTANCE_TENANT_ID on attemper_instance(TENANT_ID, 0);

/*Table structure for table attemper_instance_act */

CREATE TABLE attemper_instance_act (
  ID NVARCHAR2(64) NOT NULL,
  ACT_INST_ID NVARCHAR2(64),
  PARENT_ACT_INST_ID NVARCHAR2(64),
  PROC_INST_ID NVARCHAR2(64),
  ROOT_PROC_INST_ID NVARCHAR2(64),
  ACT_ID NVARCHAR2(255),
  ACT_NAME NVARCHAR2(255),
  ACT_TYPE NVARCHAR2(255),
  START_TIME NUMBER(13),
  END_TIME NUMBER(13),
  DURATION NUMBER(20),
  STATUS NUMBER(11),
  LOG_KEY NVARCHAR2(255),
  LOG_TEXT CLOB,
  BIZ_URI NVARCHAR2(255),
  PRIMARY KEY (ID)
) ;

create index IDX_INSTANCE_ACT_PROC_INST_ID on attemper_instance_act(PROC_INST_ID);

/*Table structure for table attemper_job */

CREATE TABLE attemper_job (
  JOB_NAME NVARCHAR2(64)  NOT NULL,
  DISPLAY_NAME NVARCHAR2(255)  ,
  CONTENT CLOB ,
  STATUS NUMBER(11),
  CONCURRENT NUMBER(1) CHECK (CONCURRENT IN (1, 0)),
  ONCE NUMBER(1) CHECK (ONCE IN (1, 0)),
  UPDATE_TIME NUMBER(13),
  REMARK NVARCHAR2(255),
  TENANT_ID NVARCHAR2(64)  NOT NULL,
  PRIMARY KEY (JOB_NAME,TENANT_ID)
) ;

/*Table structure for table attemper_job_arg */

CREATE TABLE attemper_job_arg (
  JOB_NAME NVARCHAR2(64)  NOT NULL,
  ARG_NAME NVARCHAR2(64)  NOT NULL,
  TENANT_ID NVARCHAR2(64)  NOT NULL,
  PRIMARY KEY (JOB_NAME,ARG_NAME,TENANT_ID)
) ;

/*Table structure for table attemper_job_condition */

CREATE TABLE attemper_job_condition (
  JOB_NAME NVARCHAR2(64)  NOT NULL,
  CONDITION_NAME NVARCHAR2(64)  NOT NULL,
  TENANT_ID NVARCHAR2(64)  NOT NULL,
  PRIMARY KEY (JOB_NAME,CONDITION_NAME,TENANT_ID)
) ;

/*Table structure for table attemper_job_project */

CREATE TABLE attemper_job_project (
  JOB_NAME NVARCHAR2(64)  NOT NULL,
  PROJECT_NAME NVARCHAR2(64)  ,
  TENANT_ID NVARCHAR2(64)  NOT NULL,
  PRIMARY KEY (JOB_NAME,TENANT_ID)
) ;

/*Table structure for table attemper_project */

CREATE TABLE attemper_project (
  PROJECT_NAME NVARCHAR2(64)  NOT NULL,
  PARENT_PROJECT_NAME NVARCHAR2(64)  ,
  DISPLAY_NAME NVARCHAR2(255)  ,
  CONTEXT_PATH NVARCHAR2(255)  ,
  BIND_EXECUTOR NUMBER(1) CHECK (BIND_EXECUTOR IN (1,0)),
  TENANT_ID NVARCHAR2(64)  NOT NULL,
  PRIMARY KEY (PROJECT_NAME,TENANT_ID)
) ;

/*Table structure for table attemper_project_executor */

CREATE TABLE attemper_project_executor (
  PROJECT_NAME NVARCHAR2(64) NOT NULL,
  EXECUTOR_URI NVARCHAR2(255) ,
  TENANT_ID NVARCHAR2(64) NOT NULL,
  PRIMARY KEY (PROJECT_NAME,TENANT_ID)
) ;

/*Table structure for table attemper_project_info */

CREATE TABLE attemper_project_info (
  PROJECT_NAME NVARCHAR2(64)  NOT NULL,
  URI NVARCHAR2(255) NOT NULL,
  URI_TYPE NUMBER(11),
  TENANT_ID NVARCHAR2(64)  NOT NULL,
  PRIMARY KEY (PROJECT_NAME,URI,TENANT_ID)
) ;

/*Table structure for table attemper_role */

CREATE TABLE attemper_role (
  ROLE_NAME NVARCHAR2(64)  NOT NULL,
  DISPLAY_NAME NVARCHAR2(255)  ,
  REMARK NVARCHAR2(255)  ,
  PRIMARY KEY (ROLE_NAME)
) ;

/*Table structure for table attemper_role_resource */

CREATE TABLE attemper_role_resource (
  ROLE_NAME NVARCHAR2(64) NOT NULL,
  RESOURCE_NAME NVARCHAR2(64) NOT NULL,
  PRIMARY KEY (ROLE_NAME,RESOURCE_NAME)
) ;

/*Table structure for table attemper_role_tenant */

CREATE TABLE attemper_role_tenant (
  ROLE_NAME NVARCHAR2(64) NOT NULL,
  USER_NAME NVARCHAR2(64) NOT NULL,
  PRIMARY KEY (ROLE_NAME,USER_NAME)
) ;

/*Table structure for table attemper_tenant */

CREATE TABLE attemper_tenant (
  USER_NAME NVARCHAR2(64)  NOT NULL,
  DISPLAY_NAME NVARCHAR2(255)  NOT NULL,
  PASSWORD NVARCHAR2(255)  NOT NULL,
  EMAIL NVARCHAR2(255)  ,
  MOBILE NVARCHAR2(255)  ,
  STATUS NUMBER(11) NOT NULL,
  SUPER_ADMIN NUMBER(1) CHECK (SUPER_ADMIN IN (1,0)),
  SEND_CONFIG NVARCHAR2(64)  ,
  PRIMARY KEY (USER_NAME)
) ;
